import java.io.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import org.kxml.*;
import org.kxml.io.*;
import org.kxml.kdom.*;
import org.kxml.parser.*;

/* qo}l */
public class ShopMIDlet extends MIDlet implements CommandListener
   {
   private static Display display;
   private boolean isPaused;

   private Map map;
   private Agent agent;

   private Command exitMap = new Command("}", Command.EXIT, 1);
   private Command okMap = new Command("", Command.OK, 1);
   private Command exitInfo = new Command("}", Command.EXIT, 1);
   private Command okInfo = new Command("Tw", Command.OK, 1);

   private Form shopInfoForm;
   private StringItem shopInfoSI;
   private String shopInfoString="";

   private ShopInfo[] shopinfo;
   private int numberOfInfo = 0;
   private Road[] road;
   private int numberOfRoad = 0;

   private int userXPosition = 100, userYPosition = 100;
   private int selected = -1;

   public ShopMIDlet()
      {
      shopInfoForm = new Form("Shop Navigator");
      shopInfoSI = new StringItem("",shopInfoString);
      shopInfoForm.append(shopInfoSI);
      shopInfoForm.addCommand(exitInfo);
      shopInfoForm.addCommand(okInfo);
      shopInfoForm.setCommandListener(this);

      map = new Map();
      map.addCommand(exitMap);
      map.addCommand(okMap);
      map.setCommandListener(this);

      display = Display.getDisplay(this);

      display.setCurrent(map);
      }

   // Signals the MIDlet that it has entered the Active state.
   public void startApp()
      {
      isPaused = false;
      map.repaint();
      }

   // Signals the MIDlet to enter the Paused state.
   public void pauseApp()
      {
      isPaused = true;
      }

   // Signals the MIDlet to terminate and enter the Destroyed state.
   public void destroyApp(boolean unconditional)
      {
      }

   // Indicates that a command event has occurred on Displayable d.
   public void commandAction(Command c, Displayable d)
      {
      //ϥΪ̦buufTveUuv
      if (c == exitInfo && d == shopInfoForm)
         {
         //e^uqlaϡv
         display.setCurrent(map);
         map.repaint();
         }
      //ϥΪ̦buqlaϡveUuv
      else if (c == exitMap && d == map)
         {
         //
         destroyApp(true);
         notifyDestroyed();
         };

      //ϥΪ̦buufTveUuT{v
      if (c == okInfo && d == shopInfoForm)
         {
         //eܡuqlaϡv
         display.setCurrent(map);
         }
      //ϥΪ̦buqlaϡveUuT{v
      else if(c == okMap && d == map)
         {
         //pGϥΪ̤wbqlaϤWܤ@ӰӮa
         if(selected>=0)
            {
            //NnLXӪufT]wӰӮaufT
            shopInfoString = shopinfo[selected].getMessage();
            }
         else
            {
            //MNLXϥΪ̸ơ]ܮتw]mObϥΪ̤W^
            shopInfoString = "oOثeϥΪ̪ơC";
            };
         //ܳ]wnufT
         shopInfoSI.setText(shopInfoString);
         display.setCurrent(shopInfoForm);
         };
      }





   /* oclasstdVAn */
   private class Agent implements Runnable
      {
      InputStreamReader is;
      OutputStream os;
      SocketConnection sc;
      Sender sender;

      public Agent()
         {
         Thread agentThread = new Thread(this);
         agentThread.start();
         }

      public void start()
         {
         Thread t = new Thread(this);
         t.start();
         }

      public void run()
         {
         try{
            // sܦA
            sc = (SocketConnection) Connector.open("socket://140.117.12.184:8080");
            is = new InputStreamReader(sc.openInputStream(),"UTF8");
            os = sc.openOutputStream();
            sender = new Sender(os);
            // HϥΪ̪myЬѼưeXnD
            sender.send("GET /oop/information.jsp?x="+userXPosition+"&y="+userYPosition+" HTTP/1.0\n");

            // A|^@XML
            // QKXML package}ҸѪR
            XmlParser parser = new XmlParser(is);
            Document document = new Document();
            document.parse(parser);

            // oRoot (ShopInformation) reference
            Element root = document.getRootElement();

            // ̧ǸѪRShopInfo.ContentMShopInfo.Road
            for(int i=1;i<=2;i++)
               {
               Element elea=root.getElement(i);
               if(elea.getName().equals("Content"))
                  {
                  numberOfInfo = elea.getChildCount();
                  shopinfo = new ShopInfo[numberOfInfo];
                  for(int j=0;j<elea.getChildCount();j++)
                     {
                     //̧ǸѪRShopInfo.Content.Item.*
                     Element eleb=elea.getElement(j);
                     Element sn=eleb.getElement(0);
                     Element si=eleb.getElement(1);
                     Element xp=eleb.getElement(2);
                     Element yp=eleb.getElement(3);
                     //NѪRGssShopInfo
                     shopinfo[j] = new ShopInfo(
sn.getText(),
si.getText(),
Integer.parseInt(xp.getText()),
Integer.parseInt(yp.getText() )
);
                     };
                  }
               else if(elea.getName().equals("Road"))
                  {
                  numberOfRoad = elea.getChildCount();
                  road = new Road[numberOfRoad];
                  for(int j=0;j<elea.getChildCount();j++)
                     {
                     //̧ǸѪRShopInfo.Road.Item.*
                     Element eleb=elea.getElement(j);
                     Element rn=eleb.getElement(0);
                     Element sx=eleb.getElement(1);
                     Element sy=eleb.getElement(2);
                     Element ex=eleb.getElement(3);
                     Element ey=eleb.getElement(4);
                     //NѪRGssRoad
                     road[j] = new Road(
rn.getText(),
Integer.parseInt(sx.getText()),
Integer.parseInt(sy.getText()),
Integer.parseInt(ex.getText()),
Integer.parseInt(ey.getText())
);
                     };
                  };
               };
               is.close();
               }
            catch(Exception e)
               {
               };
            }
   }


/* oclassOӦVAeXnDΪ */
private class Sender extends Thread
   {

   private OutputStream os;
   private String message;

   public Sender(OutputStream os)
      {
      this.os = os;
      start();
      }

   public synchronized void send(String msg)
      {
      message = msg;
      notify();
      }

   public synchronized void run()
      {
      while (true)
         {
         if (message == null)
            {
            try
               {
               wait();
               }
            catch (InterruptedException e)
               {
               };
            };

         if (message == null)
            {
            break;
            };

         try
            {
            os.write(message.getBytes());
            os.write("\r\n".getBytes());
            }
         catch (IOException ioe)
            {
            ioe.printStackTrace();
            };
            message = null;
         };
      }

   public synchronized void stop()
      {
      message = null;
      notify();
      }
   }





/* oclasstdeqla */
private class Map extends Canvas implements Runnable
   {

   public Map()
      {
      // agents_ӦVA
      // o˫ݷ|~|ƥiH@eϪ̾
      agent = new Agent();
      Thread mapThread = new Thread(this);
      try
         {
         // ]agent|zLs
         // |C ҥH@U
         mapThread.sleep(1000);
         }
      catch(Exception e)
         {
         };
      // }le
      mapThread.start();
      }

   public void run()
      {
      // e
      repaint();
      }

   public void paint(Graphics g)
      {
      // eXaϳ̩h
      g.setColor(0x00CCCCCC);
      g.fillRect(0,0,200,200);

      // oϥΪ̦mõebaϤW
      int userX=userXPosition;
      int userY=userYPosition;
      g.setColor(0x001155CC);
      g.drawLine(userX-3,userY,userX+3,userY);
      g.drawLine(userX,userY-2,userX,userY+4);
      g.drawArc(userX-3,userY-9,7,7,0,359);
      g.drawLine(userX,userY+4,userX+4,userY+6);
      g.drawLine(userX,userY+4,userX-4,userY+6);

      // eX
      g.setColor(0x00000000);
      if(selected == -1)
         {
         g.drawRect(userX-10,userY-11,20,20);
         }
      else
         {
         g.drawLine(shopinfo[selected].getX(), shopinfo[selected].getY()+15,(shopinfo[selected].getX()+shopinfo[selected].getName().length())*12, shopinfo[selected].getY()+15);
         };

      // eXufTӮa
      g.setColor(0x000086D6);
      for(int i=0;i<numberOfInfo;i++)
         {
         g.drawString( i+". "+shopinfo[i].getName(), shopinfo[i].getX(), shopinfo[i].getY(), g.LEFT | g.TOP );
         };

      // eXaϤW
      g.setColor(0x0000007B);
      for(int i=0;i<numberOfRoad;i++)
         {
         g.drawLine( road[i].getStartX(), road[i].getStartY(), road[i].getEndX(), road[i].getEndY() );
         };

      }

   // QUɭԴNˬd
   public void keyPressed(int key)
      {
      // pGFuUv
      if( key == -1 && selected >= 0 )
         {
         selected=selected-1;
         }
      // pGFuWv
      else if( key == -2 && selected < numberOfInfo-1 )
         {
         selected=selected+1;
         }
      repaint();
      }
   }






}

